#include "../gametoy.h"

// Simple sprite mask
unsigned char PROGMEM spritemask[8] = {
	0x18, 0x3C, 0x7E, 0xFF, 
	0xFF, 0x7E, 0x3C, 0x18
};

// Simple sprite
unsigned char PROGMEM spritedata[8] = {
	0x18, 0x3c&~0x18, 0x7e&~0x3C, 0xff&~0x7E, 
	0xff&~0x7E, 0x7e&~0x3C, 0x3c&~0x18, 0x18
};

short vtx[12*2];
unsigned char edge0[128];
unsigned char edge1[128];

void edge(char x1, char y1, char x2, char y2)
{
	char i;
	char x = x1;
    short y = y1 << 8;
	short yi = 0;
	char xdif = abs(x1-x2);
	if (!xdif)
		return;
	yi = (((short)y2-(short)y1) << 8) / (x2-x1);

	if (x1 > x2)
	{
		x = x2;
		y = y2 << 8;
	}
	for (i = 0; i < xdif; i++)
	{
		char ypos = y >> 8;
		if (edge0[x] > ypos)
			edge0[x] = ypos;
		if (edge1[x] < ypos)
			edge1[x] = ypos;

		x++;
		y += yi;
	}
}

void line(char x1, char y1, char x2, char y2, char on)
{
	char xdif = abs(x1-x2);
	char ydif = abs(y1-y2);
	if (xdif > ydif)
	{
		char i;
		char x = x1;
        short y = y1 << 8;
		short yi = 0;
		if (xdif)
			yi= (((short)y2-(short)y1) << 8) / (x2-x1);
		if (x1 > x2)
		{
			x = x2;
			y = y2 << 8;
		}
		for (i = 0; i < xdif; i++)
		{
			putpixel(x, y >> 8, on);
			x++;
			y += yi;
		}
	}
	else
	{
		char i;
		char y = y1;
        short x = x1 << 8;
		short xi = 0;
		if (ydif)
			xi = (((short)x2-(short)x1) << 8) / (y2-y1);
		if (y1 > y2)
		{
			y = y2;
			x = x2 << 8;
		}
		for (i = 0; i < ydif; i++)
		{
			putpixel(x >> 8, y, on);
			y++;
			x += xi;
		}
	}
}

void tri(char v1, char v2, char v3, char on)
{
	unsigned char i;

	memset(edge0, 0xff, 128);
	memset(edge1, 0, 128);

	edge(vtx[v1 + 0], vtx[v1 + 1], vtx[v2 + 0], vtx[v2 + 1]);
	edge(vtx[v1 + 0], vtx[v1 + 1], vtx[v3 + 0], vtx[v3 + 1]);
	edge(vtx[v3 + 0], vtx[v3 + 1], vtx[v2 + 0], vtx[v2 + 1]);

	for (i = 0; i < 128; i++)
	{
		if (edge1[i])
		{
			scanlineon(i, edge0[i], edge1[i]);
		}
	}
	
}


void mainloop()
{
	int i;
	static short c = 0;
	short sy,cy;
	unsigned char yr;
	memset(fb, 0, 16*64);
	c = tick;
	c /= 16;
	

	for (i = 0; i < 128; i++)
	{
		scanlineon(i,ROMDATA(sintable[(c + i*2)&0xff])>>3,
					 (ROMDATA(sintable[(c + i*2)&0xff])>>3)+32);
		scanlineoff(i,(ROMDATA(sintable[(c + i*4)&0xff])>>4),
				 	  (ROMDATA(sintable[(c + i*4)&0xff])>>4)+32);
	}
	
	drawtext8(8+ROMDATA(sintable[c&0xff])/16,2, "Hello World!");

	drawtext4(2,6, "Score(?) font 1234567890");


	{
		unsigned char i;
		for (i = 0; i < 16; i++)
		{
			unsigned char x1 = (c + (i<<2));
			unsigned char y1 = x1+64;
			unsigned char x2 = (c + (i<<4));
			unsigned char y2 = x2+64;
			unsigned short x = ROMDATA(sintable[x2]);
			unsigned short y = ROMDATA(sintable[y2]);
			x += ROMDATA(sintable[x1]);
			x *= i+96;
			x >>= 9;

			y += ROMDATA(sintable[y1]);
			y *= i+96;
			y >>= 10;
			
			drawsprite(x, y, spritemask,spritedata);
		}
	}
#define DIST 4

	vtx[0 * 2 + 0] = 0 * DIST;
	vtx[0 * 2 + 1] = 0 * DIST;

	vtx[1 * 2 + 0] = 2 * DIST;
	vtx[1 * 2 + 1] = 0 * DIST;

	vtx[2 * 2 + 0] = 0 * DIST;
	vtx[2 * 2 + 1] = -7 * DIST;

	vtx[3 * 2 + 0] = 2 * DIST;
	vtx[3 * 2 + 1] = -7 * DIST;

	vtx[4 * 2 + 0] = -6 * DIST;
	vtx[4 * 2 + 1] = 1 * DIST;

	vtx[5 * 2 + 0] = -6 * DIST;
	vtx[5 * 2 + 1] = 3 * DIST;

	vtx[6 * 2 + 0] = 6 * DIST;
	vtx[6 * 2 + 1] = 1 * DIST;

	vtx[7 * 2 + 0] = 4 * DIST;
	vtx[7 * 2 + 1] = 3 * DIST;

	vtx[8 * 2 + 0] = 6 * DIST;
	vtx[8 * 2 + 1] = 7 * DIST;

	vtx[9 * 2 + 0] = 4 * DIST;
	vtx[9 * 2 + 1] = 5 * DIST;

	vtx[10 * 2 + 0] = -6 * DIST;
	vtx[10 * 2 + 1] = 7 * DIST;

	vtx[11 * 2 + 0] = -6 * DIST;
	vtx[11 * 2 + 1] = 5 * DIST;

	yr = (c >> 2) & 0xff;

	sy = (signed char)(ROMDATA(sintable[yr])^0x80);

	yr += 64;

	cy = (signed char)(ROMDATA(sintable[yr])^0x80);

	for (i = 0; i < 12 * 2; i += 2)
	{
		short x,z;

		z = 0 - vtx[i + 0] * sy;
		x = 0 + vtx[i + 0] * cy;
		z >>= 7;
		vtx[i + 0] = x >> 7;

		vtx[i + 0] = ((vtx[i + 0] * (z + 100)) >> 7) + 64;
		vtx[i + 1] = ((vtx[i + 1] * (z + 100)) >> 7) + 32;
	}

	for (i = 0; i < 5; i++)
	{
		tri(0 + i * 4,2 + i * 4,4 + i * 4,1);
		tri(4 + i * 4,2 + i * 4,6 + i * 4,1);
	}
	
}
